/*
 * Project name:
     DALI_Example.vtft
 * Generated by:
     Visual TFT
 * Date of creation
     10/11/2012
 * Time of creation
     4:28:40 PM
 * Test configuration:
     MCU:             STM32F407VG
     Dev.Board:       EasyMx_PRO_v7_for_STM32_ARM
                      http://www.mikroe.com/eng/products/view/852/easymx-pro-v7-for-stm32/

                      ac:DALI
     Oscillator:      168000000 Hz
     SW:              mikroC PRO for ARM
                      http://www.mikroe.com/eng/products/view/752/mikroc-pro-for-arm/
 */

#include "DALI_Example_objects.h"
#include "DALI_defs.h"
#include "DALI-pub.h"
#include "Timer.h"

//configure DALI pins
sbit _OUT_LINE  at GPIOC_ODR.B2;            //Tx line
sbit _IN_LINE   at GPIOD_IDR.B10;           //Rx line

void main() {
  //set input/output pins for DALI protocol
  GPIO_Digital_Input (&GPIOD_BASE, _GPIO_PINMASK_10); // Set PORTD as digital input
  GPIO_Digital_Output(&GPIOC_BASE, _GPIO_PINMASK_2);
  //initialise DALI network - master device
  DALI_init();
  
  //start touchpanel
  Start_TP();

  while (1) {

    Check_TP();
    
    if(dali_state == BACKWARD_FRAME_RECEIVED)
    {
      unsigned char currentValue, i;
      currentValue = 0;
      
      if(dali_array_receive_buffer[0])
      {
         for(i = 1; i < 9; i++)
        {
          currentValue |= (dali_array_receive_buffer[i] << (8 - i));
        }
      }
      
      IntToStr(currentValue, BtnScreenQueriesAnswer.Caption);
      DrawRoundButton(&BtnScreenQueriesAnswer);
    }
    
    //get DALI status - master
    dali_state = DALI_Master_Status();
  }
}