typedef enum {_taLeft, _taCenter, _taRight} TTextAlign;

typedef struct Screen TScreen;

typedef struct  Button {
  TScreen*  OwnerScreen;
  char          Order;
  unsigned int  Left;
  unsigned int  Top;
  unsigned int  Width;
  unsigned int  Height;
  char          Pen_Width;
  unsigned int  Pen_Color;
  char          Visible;
  char          Active;
  char          Transparent;
  char          *Caption;
  TTextAlign    TextAlign;
  const char    *FontName;
  unsigned int  Font_Color;
  char          Gradient;
  char          Gradient_Orientation;
  unsigned int  Gradient_Start_Color;
  unsigned int  Gradient_End_Color;
  unsigned int  Color;
  char          PressColEnabled;
  unsigned int  Press_Color;
  void          (*OnUpPtr)();
  void          (*OnDownPtr)();
  void          (*OnClickPtr)();
  void          (*OnPressPtr)();
} TButton;

typedef struct  Button_Round {
  TScreen*  OwnerScreen;
  char          Order;
  unsigned int  Left;
  unsigned int  Top;
  unsigned int  Width;
  unsigned int  Height;
  char          Pen_Width;
  unsigned int  Pen_Color;
  char          Visible;
  char          Active;
  char          Transparent;
  char          *Caption;
  TTextAlign    TextAlign;
  const char    *FontName;
  unsigned int  Font_Color;
  char          Gradient;
  char          Gradient_Orientation;
  unsigned int  Gradient_Start_Color;
  unsigned int  Gradient_End_Color;
  unsigned int  Color;
  char          Corner_Radius;
  char          PressColEnabled;
  unsigned int  Press_Color;
  void          (*OnUpPtr)();
  void          (*OnDownPtr)();
  void          (*OnClickPtr)();
  void          (*OnPressPtr)();
} TButton_Round;

typedef const struct  CButton_Round {
  TScreen*  OwnerScreen;
  char          Order;
  unsigned int  Left;
  unsigned int  Top;
  unsigned int  Width;
  unsigned int  Height;
  char          Pen_Width;
  unsigned int  Pen_Color;
  char          Visible;
  char          Active;
  char          Transparent;
  const char          *Caption;
  TTextAlign    TextAlign;
  const char    *FontName;
  unsigned int  Font_Color;
  char          Gradient;
  char          Gradient_Orientation;
  unsigned int  Gradient_Start_Color;
  unsigned int  Gradient_End_Color;
  unsigned int  Color;
  char          Corner_Radius;
  char          PressColEnabled;
  unsigned int  Press_Color;
  void          (*OnUpPtr)();
  void          (*OnDownPtr)();
  void          (*OnClickPtr)();
  void          (*OnPressPtr)();
} TCButton_Round;

typedef struct  Label {
  TScreen*  OwnerScreen;
  char          Order;
  unsigned int  Left;
  unsigned int  Top;
  unsigned int  Width;
  unsigned int  Height;
  char          *Caption;
  const char    *FontName;
  unsigned int  Font_Color;
  char          Visible;
  char          Active;
  void          (*OnUpPtr)();
  void          (*OnDownPtr)();
  void          (*OnClickPtr)();
  void          (*OnPressPtr)();
} TLabel;

typedef const struct  CLabel {
  TScreen*  OwnerScreen;
  char          Order;
  unsigned int  Left;
  unsigned int  Top;
  unsigned int  Width;
  unsigned int  Height;
  const char          *Caption;
  const char    *FontName;
  unsigned int  Font_Color;
  char          Visible;
  char          Active;
  void          (*OnUpPtr)();
  void          (*OnDownPtr)();
  void          (*OnClickPtr)();
  void          (*OnPressPtr)();
} TCLabel;

typedef struct  Image {
  TScreen*  OwnerScreen;
  char          Order;
  unsigned int  Left;
  unsigned int  Top;
  unsigned int  Width;
  unsigned int  Height;
  const char    *Picture_Name;
  char          Visible;
  char          Active;
  char          Picture_Type;
  char          Picture_Ratio;
  void          (*OnUpPtr)();
  void          (*OnDownPtr)();
  void          (*OnClickPtr)();
  void          (*OnPressPtr)();
} TImage;

typedef struct  Circle {
  TScreen*  OwnerScreen;
  char          Order;
  unsigned int  Left;
  unsigned int  Top;
  unsigned int  Radius;
  char          Pen_Width;
  unsigned int  Pen_Color;
  char          Visible;
  char          Active;
  char          Transparent;
  char          Gradient;
  char          Gradient_Orientation;
  unsigned int  Gradient_Start_Color;
  unsigned int  Gradient_End_Color;
  unsigned int  Color;
  char          PressColEnabled;
  unsigned int  Press_Color;
  void          (*OnUpPtr)();
  void          (*OnDownPtr)();
  void          (*OnClickPtr)();
  void          (*OnPressPtr)();
} TCircle;

typedef struct  Box {
  TScreen*  OwnerScreen;
  char          Order;
  unsigned int  Left;
  unsigned int  Top;
  unsigned int  Width;
  unsigned int  Height;
  char          Pen_Width;
  unsigned int  Pen_Color;
  char          Visible;
  char          Active;
  char          Transparent;
  char          Gradient;
  char          Gradient_Orientation;
  unsigned int  Gradient_Start_Color;
  unsigned int  Gradient_End_Color;
  unsigned int  Color;
  char          PressColEnabled;
  unsigned int  Press_Color;
  void          (*OnUpPtr)();
  void          (*OnDownPtr)();
  void          (*OnClickPtr)();
  void          (*OnPressPtr)();
} TBox;

struct Screen {
  unsigned int           Color;
  unsigned int           Width;
  unsigned int           Height;
  unsigned short         ObjectsCount;
  unsigned int           ButtonsCount;
  TButton                * const code *Buttons;
  unsigned int           Buttons_RoundCount;
  TButton_Round          * const code *Buttons_Round;
  unsigned int           CButtons_RoundCount;
  TCButton_Round          * const code *CButtons_Round;
  unsigned int           LabelsCount;
  TLabel                 * const code *Labels;
  unsigned int           CLabelsCount;
  TCLabel                 * const code *CLabels;
  unsigned int           ImagesCount;
  TImage                 * const code *Images;
  unsigned int           CirclesCount;
  TCircle                * const code *Circles;
  unsigned int           BoxesCount;
  TBox                   * const code *Boxes;
};

extern   TScreen                Screen1;
extern   TImage               Image1;
extern   TBox                   Box7;
extern   TBox                   BoxLightIn04;
extern   TBox                   BoxLightIn03;
extern   TBox                   BoxLightIn01;
extern   TButton               Button1;
extern   TButton               Button2;
extern   TLabel                 Label4;
extern   TButton               Button3;
extern   TButton               Button4;
extern   TButton               Button5;
extern   TBox                   BoxLightIn02;
extern   TCircle                CircleLightOut02;
extern   TCircle                CircleLightOut03;
extern   TCircle                CircleLightOut04;
extern   TCircle                CircleLightOut05;
extern   TCircle                CircleLightOut06;
extern   TCircle                CircleLightOut01;
extern   TButton               Button6;
extern   TButton               Button7;
extern   TButton               Button8;
extern   TButton_Round          BtnBackSetLights;
extern   TButton                * const code Screen1_Buttons[8];
extern   TButton_Round          * const code Screen1_Buttons_Round[1];
extern   TLabel                 * const code Screen1_Labels[1];
extern   TImage                 * const code Screen1_Images[1];
extern   TCircle                * const code Screen1_Circles[6];
extern   TBox                   * const code Screen1_Boxes[5];


extern   TScreen                Screen2;
extern   TButton               Button10;
extern   TLabel                 Label1;
extern   TButton               BtnSetArc;
extern   TButton               BtnSendQueryCmd;
extern   TButton               BtnSetSceneLevel;
extern   TLabel                 Label14;
extern   TButton                * const code Screen2_Buttons[4];
extern   TLabel                 * const code Screen2_Labels[2];


extern   TScreen                Screen3;
extern   TImage               Image2;
extern   TBox                   Box4;
extern   TBox                   Box3;
extern   TBox                   Box1;
extern   TBox                   Box2;
extern   TCircle                Circle2;
extern   TCircle                Circle3;
extern   TCircle                Circle4;
extern   TCircle                Circle5;
extern   TCircle                Circle6;
extern   TCircle                Circle1;
extern   TBox                   Box5;
extern   TLabel                 Label2;
extern   TLabel                 Label3;
extern   TLabel                 Label5;
extern   TLabel                 Label6;
extern   TLabel                 Label7;
extern   TLabel                 Label8;
extern   TLabel                 Label9;
extern   TLabel                 Label10;
extern   TLabel                 Label11;
extern   TLabel                 Label12;
extern   TButton_Round          BtnArcLevelDown;
extern   TButton_Round          BtnArcLevelUp;
extern   TButton_Round          ButtonRound3;
extern   TButton_Round          BtnBallastArcLevel;
extern   TButton_Round          * const code Screen3_Buttons_Round[4];
extern   TLabel                 * const code Screen3_Labels[10];
extern   TImage                 * const code Screen3_Images[1];
extern   TCircle                * const code Screen3_Circles[6];
extern   TBox                   * const code Screen3_Boxes[5];


extern   TScreen                ScreenSetScene;
extern   TCButton_Round          BtnBalAddrUp;
extern   TCButton_Round          BtnBalAddrDown;
extern   TCLabel          Label15;
extern   TCButton_Round          BtnBackScene;
extern   TCButton_Round          BtnSetSceneBallast;
extern   TCButton_Round          BtnSceneNumUp;
extern   TCButton_Round          BtnSceneNumDown;
extern   TCLabel          Label19;
extern   TButton_Round          btnBallastAddressText;
extern   TButton_Round          btnSceneNumberText;
extern   TButton_Round          * const code Screen4_Buttons_Round[2];
extern   TCButton_Round          * const code Screen4_CButtons_Round[6];
extern   TCLabel                 * const code Screen4_CLabels[2];


extern   TScreen                ScreenQueries;
extern   TCButton_Round          BtnBackQueries;
extern   TCButton_Round          BtnQueryActualLevel;
extern   TButton_Round          BtnSelectBallastQuery;
extern   TCButton_Round          BtnScreenQueriesBalUp;
extern   TCButton_Round          BtnScreenQueriesBalDown;
extern   TButton_Round          BtnScreenQueriesAnswer;
extern   TLabel                 Label13;
extern   TCButton_Round          BtnQueryBallast;
extern   TCButton_Round          BtnQueryDeviceType;
extern   TCButton_Round          BtnQueryGroup0_7;
extern   TCButton_Round          BtnQueryGroup8_15;
extern   TButton_Round          * const code Screen5_Buttons_Round[2];
extern   TCButton_Round          * const code Screen5_CButtons_Round[8];
extern   TLabel                 * const code Screen5_Labels[1];



/////////////////////////
// Events Code Declarations
void Box1OnClick();
void Box2OnClick();
void Box3OnClick();
void Box4OnClick();
void BoxLightIn01OnClick();
void BoxLightIn02OnClick();
void BoxLightIn03OnClick();
void BoxLightIn04OnClick();
void BtnArcLevelDownOnClick();
void BtnArcLevelUpOnClick();
void BtnBackQueriesOnClick();
void BtnBackSceneOnClick();
void BtnBackSetLightsOnClick();
void BtnBalAddrDownOnClick();
void BtnBalAddrUpOnClick();
void BtnQueryActualLevelOnClick();
void BtnQueryBallastOnClick();
void BtnQueryDeviceTypeOnClick();
void BtnQueryGroup0_7OnClick();
void BtnQueryGroup8_15OnClick();
void BtnSceneNumDownOnClick();
void BtnSceneNumUpOnClick();
void BtnScreenQueriesBalDownOnClick();
void BtnScreenQueriesBalUpOnClick();
void BtnSendQueryCmdOnClick();
void BtnSetArcOnClick();
void BtnSetSceneBallastOnClick();
void BtnSetSceneLevelOnClick();
void Button10OnClick();
void Button1OnClick();
void Button2OnClick();
void Button3OnClick();
void Button4OnClick();
void Button5OnClick();
void Button6OnClick();
void Button7OnClick();
void Button8OnClick();
void ButtonRound3OnClick();
void Circle1OnClick();
void Circle2OnClick();
void Circle3OnClick();
void Circle4OnClick();
void Circle5OnClick();
void Circle6OnClick();
void CircleLightOut01OnClick();
void CircleLightOut02OnClick();
void CircleLightOut03OnClick();
void CircleLightOut04OnClick();
void CircleLightOut05OnClick();
void CircleLightOut06OnClick();
/////////////////////////

/////////////////////////////////
// Caption variables Declarations
extern char Image1_Caption[];
extern char Box7_Caption[];
extern char BoxLightIn04_Caption[];
extern char BoxLightIn03_Caption[];
extern char BoxLightIn01_Caption[];
extern char Button1_Caption[];
extern char Button2_Caption[];
extern char Label4_Caption[];
extern char Button3_Caption[];
extern char Button4_Caption[];
extern char Button5_Caption[];
extern char BoxLightIn02_Caption[];
extern char CircleLightOut02_Caption[];
extern char CircleLightOut03_Caption[];
extern char CircleLightOut04_Caption[];
extern char CircleLightOut05_Caption[];
extern char CircleLightOut06_Caption[];
extern char CircleLightOut01_Caption[];
extern char Button6_Caption[];
extern char Button7_Caption[];
extern char Button8_Caption[];
extern char BtnBackSetLights_Caption[];
extern char Button10_Caption[];
extern char Label1_Caption[];
extern char BtnSetArc_Caption[];
extern char BtnSendQueryCmd_Caption[];
extern char BtnSetSceneLevel_Caption[];
extern char Label14_Caption[];
extern char Image2_Caption[];
extern char Box4_Caption[];
extern char Box3_Caption[];
extern char Box1_Caption[];
extern char Box2_Caption[];
extern char Circle2_Caption[];
extern char Circle3_Caption[];
extern char Circle4_Caption[];
extern char Circle5_Caption[];
extern char Circle6_Caption[];
extern char Circle1_Caption[];
extern char Box5_Caption[];
extern char Label2_Caption[];
extern char Label3_Caption[];
extern char Label5_Caption[];
extern char Label6_Caption[];
extern char Label7_Caption[];
extern char Label8_Caption[];
extern char Label9_Caption[];
extern char Label10_Caption[];
extern char Label11_Caption[];
extern char Label12_Caption[];
extern char BtnArcLevelDown_Caption[];
extern char BtnArcLevelUp_Caption[];
extern char ButtonRound3_Caption[];
extern char BtnBallastArcLevel_Caption[];
extern const char BtnBalAddrUp_Caption[];
extern const char BtnBalAddrDown_Caption[];
extern const char Label15_Caption[];
extern const char BtnBackScene_Caption[];
extern const char BtnSetSceneBallast_Caption[];
extern const char BtnSceneNumUp_Caption[];
extern const char BtnSceneNumDown_Caption[];
extern const char Label19_Caption[];
extern char btnBallastAddressText_Caption[];
extern char btnSceneNumberText_Caption[];
extern const char BtnBackQueries_Caption[];
extern const char BtnQueryActualLevel_Caption[];
extern char BtnSelectBallastQuery_Caption[];
extern const char BtnScreenQueriesBalUp_Caption[];
extern const char BtnScreenQueriesBalDown_Caption[];
extern char BtnScreenQueriesAnswer_Caption[];
extern char Label13_Caption[];
extern const char BtnQueryBallast_Caption[];
extern const char BtnQueryDeviceType_Caption[];
extern const char BtnQueryGroup0_7_Caption[];
extern const char BtnQueryGroup8_15_Caption[];
/////////////////////////////////

void DrawScreen(TScreen *aScreen);
void DrawButton(TButton *aButton);
void DrawRoundButton(TButton_Round *Around_button);
void DrawCRoundButton(TCButton_Round *ACround_button);
void DrawLabel(TLabel *ALabel);
void DrawCLabel(TCLabel *AClabel);
void DrawImage(TImage *AImage);
void DrawCircle(TCircle *ACircle);
void DrawBox(TBox *ABox);
void Check_TP();
void Start_TP();
